/****************************************************************************/
/*                               Beebem                                     */
/*                               ------                                     */
/* This program may be distributed freely within the following restrictions:*/
/*                                                                          */
/* 1) You may not charge for this program or for any part of it.            */
/* 2) This copyright message must be distributed with all copies.           */
/* 3) This program must be distributed complete with source code.  Binary   */
/*    only distribution is not permitted.                                   */
/* 4) The author offers no warrenties, or guarentees etc. - you use it at   */
/*    your own risk.  If it messes something up or destroys your computer   */
/*    thats YOUR problem.                                                   */
/* 5) You may use small sections of code from this program in your own      */
/*    applications - but you must acknowledge its use.  If you plan to use  */
/*    large sections then please ask the author.                            */
/*                                                                          */
/* If you do not agree with any of the above then please do not use this    */
/* program.                                                                 */
/****************************************************************************/
/* Mike Wyatt and NRM's port to win32 - 7/6/97 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include <SDL.h>


#include <iostream>
#include "include/windows.h"

#include "include/6502core.h"
#include "include/beebmem.h"
#include "include/beebsound.h"
#include "include/sysvia.h"
#include "include/uservia.h"
#include "include/beebwin.h"
#include "include/disc8271.h"
#include "include/video.h"
#include "include/via.h"
#include "include/atodconv.h"
#include "include/disc1770.h"
#include "include/serial.h"
#include "include/tube.h"
#include "include/econet.h"	//Rob

#include "include/line.h"	// SDL Stuff
#include "include/log.h"
#include "include/sdl.h"

#include "include/gui.h"

#include "include/beebem_pages.h"

#ifdef MULTITHREAD
#undef MULTITHREAD
#endif

/* Make global reference to command line args
 */
int __argc = 0;
char **__argv = NULL;

/* This needs to be fixed.. ----
 */
int Tmp_Command_Line_Fullscreen=0;
/* -----------------------------
 */



extern VIAState SysVIAState;
int DumpAfterEach=0;

unsigned char MachineType;
BeebWin *mainWin = NULL;

//-- HINSTANCE hInst;
//-- HWND hCurrentDialog = NULL;

//-- DWORD iSerialThread,iStatThread; // Thread IDs
FILE *tlog;


//----------------------------------------------

int done = 0;
int fullscreen = 0;
int showing_menu = 0;
EG_Window *displayed_window_ptr = NULL;


//void CLEAN_EXIT(void)
//{
//  /* Quit SDL
//   */
//  SDL_Quit();
//}


void SetActiveWindow(EG_Window *window_ptr)
{
	displayed_window_ptr = window_ptr;
}

int GetFullscreenState(void)
{
	return(fullscreen);
}

int ToggleFullscreen(void)
{
	if (fullscreen != 0)
		fullscreen = 0;
	else
		fullscreen = 1;

	if (SDL_WM_ToggleFullScreen(screen_ptr) != 1)
		EG_Log(EG_LOG_WARNING, dL"Could not toggle full-screen mode.", dR);

	return(fullscreen);
}

void ShowingMenu(void)
{
	showing_menu = 1;
}

void NoMenuShown(void)
{
	showing_menu = 0;
}

void Quit(void)
{
	done=1;
}



//------------------------------------------------

//-- int CALLBACK WinMain(HINSTANCE hInstance, 
//-- 					HINSTANCE hPrevInstance,
//-- 					LPSTR lpszCmdLine,
//-- 					int nCmdShow)
//-- { 
int main(int argc, char *argv[]){
//--	MSG msg;

//--	hInst = hInstance;

	/* Create global reference to command line args (like windows does)
	 */
	__argc = argc;
	__argv = (char**) argv;

	

	/* Initialise debugging subsystem.
	 */
	DEBUG_INIT();

	/* Initialize SDL resources.
	 */
	if (! InitialiseSDL(argc, argv)){
		pFATAL("Unable to initialise SDL library!");
		exit(1);
	}

/* Initialize GUI API
 */
	if (EG_Initialize() == EG_TRUE){
		printf("EG initialized\n");
	}else{
		printf("EG FAILED TO INITIALIZE\n");
		exit(1);
	}



	/* Build menus:
	*/
	if (InitializeBeebEmGUI(screen_ptr) != EG_TRUE)
		exit(1);


	  /* Clean-up at exit
  	 */
//  	atexit(CLEAN_EXIT);

	/* ---------------------------------------
	 */

	mainWin=new BeebWin();
	mainWin->Initialise();

	/* ------------------------------------------------------
	 */

	// Create serial threads
//--	InitThreads();
//--	CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) SerialThread,NULL,0,&iSerialThread);
//--	CreateThread(NULL,0,(LPTHREAD_START_ROUTINE) StatThread,NULL,0,&iStatThread);

	/* -------------------------------------------------0----------
	 */

//    tlog = fopen("\\trace.log", "wt");


	/* Clear SDL event queue
	 */
	EG_Draw_FlushEventQueue();



	/* Main loop converted to SDL:
	 */
	pDEBUG(dL"Got to main loop!", dR);
	done = 0; do{

//--		if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) || mainWin->IsFrozen())
//--		{
//--			if(!GetMessage(&msg,    // message structure
//--							NULL,   // handle of window receiving the message
//--							0,      // lowest message to examine
//--							0))
//--				break;              // Quit the app on WM_QUIT
//--  
//--			if (hCurrentDialog == NULL || !IsDialogMessage(hCurrentDialog, &msg)) {
//--				TranslateMessage(&msg);// Translates virtual key codes
//--				DispatchMessage(&msg); // Dispatches message to window
//--			}
//--		}

		SDL_Event event;


		if (showing_menu != 1){



		while (SDL_PollEvent(&event))
			switch (event.type)
			{
			case SDL_QUIT:
				done=1;
			break;

			case SDL_KEYDOWN:
			case SDL_KEYUP:
				{
					int pressed=0, col=0, row=0;
			

					if (event.key.keysym.sym == SDLK_F12)
						Show_Main();

					if (event.key.keysym.sym == SDLK_END)
						done=1;

					pressed = col = row = 0;

					/* Handle shift booting:
					 */
					if (mainWin->m_ShiftBooted){
						mainWin->m_ShiftBooted = false;
						BeebKeyUp(0, 0);
					}

					/* Convert SDL key press into BBC key press:
					 */
					if (ConvertSDLKeyToBBCKey(event.key.keysym, &pressed, &col, &row)){
						/* Process key in emulator core:
						 */
						if (pressed)
							BeebKeyDown(row, col);
						else
							BeebKeyUp(row, col);
					}
				}
			}
		
		/* Execute emulator:
		 */
		if (!mainWin->IsFrozen())
			Exec6502Instruction();


		}else{


			/* Process window manager signals:
			 */
			while ( SDL_PollEvent(&event) ){
				switch (event.type)
				{
				case SDL_QUIT:
				done=1;
				break;
#				ifdef EG_DEBUG
				/* For now allow exit with ESCAPE.
				 */
				case SDL_KEYDOWN:
				if(event.key.keysym.sym == SDLK_ESCAPE)
					done=1;
				break;
#				endif
				}

				/* Send event to GUI:
				 */
				EG_Window_ProcessEvent(displayed_window_ptr, &event, 0, 0);
			}

//			printf("Menu mode.\n");
			SDL_Delay(50);





		}



//--	} while(1);
	} while(done==0);

//--	mainWin->KillDLLs();

//    	fclose(tlog);

	delete mainWin;
//--	Kill_Serial();

	/* Cleanly free SDL and logging.
	 */
	DestroyBeebEmGUI();

	UninitialiseSDL();
	DEBUG_FREE();

	return(0);  
} /* main */
